/* Sistemas Integrados TEKNISA
  Integrao - SAGA

 Nome: Rotina de importao das movimentaes efetuadas no sistema Estoque (SAGA)
       Ajustes / Bloqueios / Desbloqueios

Criao:
16/07/2013 - Fabrcio Marcelo

@C:\web_545\sql\end_conv\oracle\clientes\ris\6470_RISSTPO_Importa_Movi_Estoque_Saga.SQL
*/

CREATE OR REPLACE PROCEDURE IMPORTA_MOVI_ESTOQUE_SAGA
AS
   V_NRCONTADOR    INT;

   V_NRLANCESTQ    VARCHAR2(20);
   V_NRSEQITPROD   VARCHAR2(04);

   V_CDPRODUTO     VARCHAR2(10);
   V_CDPRODESTO    VARCHAR2(10);
   V_QTESTCONV     FLOAT;

   V_CDALMOXARIFE  VARCHAR2(06);
   V_CDLOCALESTOQ  VARCHAR2(06);
   V_NRLOTEESTQ    VARCHAR2(20);
   V_NRSUBLOTE     VARCHAR2(04);

   V_VRESTOQDIA    FLOAT;
   V_VRESTOQBRUT   FLOAT;

   V_DTINICIAL    DATE;
   V_DTFINAL      DATE;
   V_DATAPROC     DATE;
   V_CDFILIMOVI   VARCHAR2(04);
BEGIN
   V_NRCONTADOR := 0;
   V_NRLANCESTQ := 'A';

   FOR C_MOV IN (/* Ajuste de Estoque (Adio - Entrada) */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Adio estoque SAGA - Entrada' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.DATGRCTRSESQ AS DTMOVI,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE NOT P.CDFILIALSAGA IS NULL
                    AND NOT P.CDOPERADORSAGA IS NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 4
                    AND E.CODMTVBLQ = 'Adio'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'

                  UNION ALL

                 /* Ajuste de Estoque (Adio - Sada) */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Adio Estoque SAGA - Sada' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.DATGRCTRSESQ AS DTMOVI,
                        E.VALEMBSKU,
                        'S' AS IDENTRSAID
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE NOT P.CDFILIALSAGA IS NULL
                    AND NOT P.CDOPERADORSAGA IS NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 4
                    AND E.CODMTVBLQ = 'Adio'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'

                  UNION ALL

                 /* Bloqueio (Quarentena)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Bloqueio de Estoque SAGA (Quarentena)' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.DATGRCTRSESQ AS DTMOVI,
                        E.VALEMBSKU,
                        'S' AS IDENTRSAID
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE NOT P.CDFILIALSAGA IS NULL
                    AND NOT P.CDOPERADORSAGA IS NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 5
                    AND E.CODMTVBLQ = 'Quarentena'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'

                  UNION ALL

                 /* Desbloqueio (Quarentena)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Desbloqueio de Estoque SAGA (Quarentena)' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.DATGRCTRSESQ AS DTMOVI,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE NOT P.CDFILIALSAGA IS NULL
                    AND NOT P.CDOPERADORSAGA IS NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 5
                    AND E.CODMTVBLQ = 'Quarentena'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'

                  UNION ALL

                 /* Bloqueio (Avaria Parcial)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Bloqueio de Estoque SAGA (Avaria Parcial)' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.DATGRCTRSESQ AS DTMOVI,
                        E.VALEMBSKU,
                        'S' AS IDENTRSAID
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE NOT P.CDFILIALSAGA IS NULL
                    AND NOT P.CDOPERADORSAGA IS NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 5
                    AND E.CODMTVBLQ = 'Avaria Parcial'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'

                  UNION ALL

                 /* Desbloqueio (Avaria Parcial)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Desbloqueio de Estoque SAGA (Avaria Parcial)' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.DATGRCTRSESQ AS DTMOVI,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE NOT P.CDFILIALSAGA IS NULL
                    AND NOT P.CDOPERADORSAGA IS NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 5
                    AND E.CODMTVBLQ = 'Avaria Parcial'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'

                  UNION ALL

                 /* Bloqueio (Avaria Total)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Bloqueio de Estoque SAGA (Avaria Total)' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.DATGRCTRSESQ AS DTMOVI,
                        E.VALEMBSKU,
                        'S' AS IDENTRSAID
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE NOT P.CDFILIALSAGA IS NULL
                    AND NOT P.CDOPERADORSAGA IS NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 5
                    AND E.CODMTVBLQ = 'Avaria Total'
                    AND E.NOMTIPOPE = 'Sada'
                    AND E.FLAPRC = '0'

                  UNION ALL

                 /* Desbloqueio (Avaria Total)  */
                 SELECT E.IDCSEQ,
                        P.CDFILIAL,
                        P.CDOPERADORSAGA,
                        TO_DATE(E.DATGRCTRSESQ) AS DATGRCTRSESQ,
                        'Desbloqueio de Estoque SAGA (Avaria Total)' AS DSLANCESTQ,
                        E.CODMER,
                        E.VALQTD,
                        E.DATGRCTRSESQ AS DTMOVI,
                        E.VALEMBSKU,
                        'E' AS IDENTRSAID
                   FROM PARAMFILIAL P, INT_MOVTRSESQ E
                  WHERE NOT P.CDFILIALSAGA IS NULL
                    AND NOT P.CDOPERADORSAGA IS NULL
                    AND E.CODSTE = P.CDFILIALSAGA
                    AND E.IDCTIPTRSESQ = 5
                    AND E.CODMTVBLQ = 'Avaria Total'
                    AND E.NOMTIPOPE = 'Entrada'
                    AND E.FLAPRC = '0'

                  ORDER BY CDFILIAL, DATGRCTRSESQ, CODMER)
   LOOP
      IF SUBSTR(C_MOV.CODMER,1,1) = '7' THEN
         V_CDFILIMOVI := '0075';
      ELSE
         IF SUBSTR(C_MOV.CODMER,1,3) = '107' THEN
            V_CDFILIMOVI := '1200';
         ELSE
            IF SUBSTR(C_MOV.CODMER,1,3) = '105' THEN
               V_CDFILIMOVI := '1100';
            ELSE
               V_CDFILIMOVI := '1000';
            END IF;
         END IF;
      END IF;

      BEGIN
         SELECT DTPROCESSA
           INTO V_DATAPROC
           FROM PARAMFILIAL
          WHERE CDFILIAL = V_CDFILIMOVI;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DATAPROC := SYSDATE;
      END;

      IF C_MOV.IDENTRSAID = 'E' THEN
         NOVO_CODIGO('LANCTOEST' || V_CDFILIMOVI, V_NRLANCESTQ);

         INSERT INTO LANCTOESTOQ
           (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ, IDALTCUSMED,
            NRLANCTONF, CDFILIMOVI, CDOPERADOR,  CDALMOXARIFE,  CDLOCALESTOQ)
         VALUES
           (V_CDFILIMOVI, SUBSTR(V_NRLANCESTQ,11,10), '2', C_MOV.DATGRCTRSESQ, SUBSTR(C_MOV.DSLANCESTQ, 1, 60), 'S',
            NULL, V_CDFILIMOVI, C_MOV.CDOPERADORSAGA,  NULL,  NULL);
      ELSE
         NOVO_CODIGO('LANCTOEST' || V_CDFILIMOVI, V_NRLANCESTQ);

         INSERT INTO LANCTOESTOQ
            (CDFILIAL, CDFILIMOVI, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ,
             NRLANCTONF, CDOPERADOR, CDALMOXARIFE, CDLOCALESTOQ)
         VALUES
            (V_CDFILIMOVI, V_CDFILIMOVI, SUBSTR(V_NRLANCESTQ,11,10), '4', C_MOV.DATGRCTRSESQ, SUBSTR(C_MOV.DSLANCESTQ, 1, 60),
             NULL, C_MOV.CDOPERADORSAGA, NULL, NULL);
      END IF;

      V_NRCONTADOR := V_NRCONTADOR + 1;

      /* Verifica informaes do produto de estoque relacionado ao lanamento */
      BEGIN
         SELECT MAX(P.CDPRODUTO), MAX(P.CDPRODESTO), MAX(C_MOV.VALQTD * NVL(P.VRFATOCONV,1))
           INTO V_CDPRODUTO, V_CDPRODESTO, V_QTESTCONV
           FROM PRODUTO P
          WHERE P.CDARVPROD = C_MOV.CODMER;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDPRODUTO := NULL; V_CDPRODESTO := NULL; V_QTESTCONV := 0;
      END;

      /* Sequencial do produto */
      SELECT NVL(MAX(NRSEQUITEM),0) + 1
        INTO V_NRSEQITPROD
        FROM ITLANCTOEST
       WHERE CDFILIAL = V_CDFILIMOVI
         AND NRLANCESTQ = SUBSTR(V_NRLANCESTQ,11,10);

      /* Retorna custo do produto em estoque */
      BEGIN
         SELECT MAX(CDALMOXARIFE), MAX(CDLOCALESTOQ), MAX(NRLOTEESTQ), MAX(NRSUBLOTE),
                MAX(VRESTOQDIA), MAX(VRESTOQBRUT)
           INTO V_CDALMOXARIFE, V_CDLOCALESTOQ, V_NRLOTEESTQ, V_NRSUBLOTE,
                V_VRESTOQDIA, V_VRESTOQBRUT
           FROM POSESTDIA P
          WHERE P.CDFILIAL = V_CDFILIMOVI
            AND P.CDPRODUTO = V_CDPRODESTO
            AND P.QTESTOQDIA <> 0
            AND P.DTPOSIESTQ = (SELECT MAX(DTPOSIESTQ)
                                  FROM POSESTDIA
                                 WHERE CDFILIAL = P.CDFILIAL
                                   AND CDALMOXARIFE = P.CDALMOXARIFE
                                   AND CDLOCALESTOQ = P.CDLOCALESTOQ
                                   AND NRLOTEESTQ = P.NRLOTEESTQ
                                   AND NRSUBLOTE = P.NRSUBLOTE
                                   AND CDPRODUTO = P.CDPRODUTO
                                   AND DTPOSIESTQ <= TO_DATE(C_MOV.DATGRCTRSESQ));
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDALMOXARIFE := NULL; V_CDLOCALESTOQ := NULL; V_NRLOTEESTQ := NULL; V_NRSUBLOTE := NULL;
            V_VRESTOQDIA := 0; V_VRESTOQBRUT := 0;

      END;

      IF C_MOV.IDENTRSAID = 'E' THEN
         INSERT INTO ITLANCTOEST
            (CDFILIAL, NRLANCESTQ, NRSEQUITEM, IDTIPOMOVI,
             CDPRODUTO, QTTOTLANCTO,  VRUNILANCTO, VRTOTLANCTO,
             DTLANCMOVI, IDORDEMCLC, CDPRODMOVI, QTLANCTOEST,
             VRLANCTOBRUT, VRLANCTOEST, CDFILIMOVI, CDALMOXARIFE,
             CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
         VALUES
            (V_CDFILIMOVI, SUBSTR(V_NRLANCESTQ,11,10), LPAD(TO_CHAR(V_NRSEQITPROD), 4, '0'), '2',
             V_CDPRODUTO, V_QTESTCONV, (V_VRESTOQDIA / V_QTESTCONV), V_VRESTOQDIA,
             C_MOV.DATGRCTRSESQ, '2', V_CDPRODESTO, V_QTESTCONV,
             V_VRESTOQBRUT, V_VRESTOQDIA, V_CDFILIMOVI, V_CDALMOXARIFE,
             V_CDLOCALESTOQ, V_NRLOTEESTQ, V_NRSUBLOTE);
      ELSE
         INSERT INTO ITLANCTOEST
            (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,
             CDPRODMOVI, VRUNILANCTO, VRTOTLANCTO, QTTOTLANCTO,
             QTLANCTOEST, IDTIPOMOVI, DTLANCMOVI, IDORDEMCLC,
             VRLANCTOBRUT, VRLANCTOEST, CDFILIMOVI, CDALMOXARIFE,
             CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
         VALUES
            (V_CDFILIMOVI, SUBSTR(V_NRLANCESTQ,11,10), LPAD(TO_CHAR(V_NRSEQITPROD), 4, '0'), V_CDPRODUTO,
             V_CDPRODESTO, (V_VRESTOQDIA / V_QTESTCONV), V_VRESTOQDIA, V_QTESTCONV,
             V_QTESTCONV, '4', C_MOV.DATGRCTRSESQ, '9',
             V_VRESTOQBRUT, V_VRESTOQDIA, V_CDFILIMOVI, V_CDALMOXARIFE,
             V_CDLOCALESTOQ, V_NRLOTEESTQ, V_NRSUBLOTE);
      END IF;

      /*Atualizao de estoque de produtos*/
      IF C_MOV.DATGRCTRSESQ < V_DATAPROC THEN
         V_DTINICIAL := C_MOV.DATGRCTRSESQ;
      ELSE
         V_DTINICIAL := V_DATAPROC;
      END IF;

      IF C_MOV.DATGRCTRSESQ > V_DATAPROC THEN
         V_DTFINAL := C_MOV.DATGRCTRSESQ;
      ELSE
         V_DTFINAL := V_DATAPROC;
      END IF;

      ATUALIZA_ESTOQUE(V_CDFILIMOVI, V_DTINICIAL, V_DTFINAL, V_CDFILIMOVI, V_NRLANCESTQ);

      V_NRCONTADOR := V_NRCONTADOR + 1;

      /* Altera flag para processado */
      UPDATE INT_MOVTRSESQ
         SET FLAPRC = 1
       WHERE IDCSEQ = C_MOV.IDCSEQ;

      IF V_NRCONTADOR = 500 THEN
         V_NRCONTADOR := 0;
         COMMIT;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_MOVI_ESTOQUE_SAGA','5.45.XXX'); END;
/
